## block-device-id 0.1.1

=== examples/Makefile ===
# Makefile for libblockdeviceid example
#
# Build with: make
# Clean with: make clean

CC ?= gcc
CFLAGS ?= -Wall -Wextra -O2
LDFLAGS ?=
LIBS = -lblockdeviceid

PROG = get_device_id

all: $(PROG)

$(PROG): get_device_id.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)

clean:
	rm -f $(PROG)

.PHONY: all clean

## block-device-id 0.1.0

=== debian/changelog ===
block-device-id (0.1.0) trixie; urgency=medium

  * Initial release

 -- Richard Oliver <richard.oliver@raspberrypi.com>  Tue, 27 Jan 2026 15:35:31 +0000

=== debian/control ===
Source: block-device-id
Section: libs
Priority: optional
Maintainer: Richard Oliver <richard.oliver@raspberrypi.com>
Build-Depends: debhelper-compat (= 13),
               dh-cargo (>= 25),
               cbindgen,
               librust-tempfile-dev,
               librust-libc-dev,
               librust-nix-dev (>= 0.29),
               librust-clap-dev (>= 4),
               librust-clap-mangen-dev
Standards-Version: 4.7.2
Homepage: https://github.com/raspberrypi/block-device-id
Vcs-Git: https://github.com/raspberrypi/block-device-id.git
Vcs-Browser: https://github.com/raspberrypi/block-device-id
Rules-Requires-Root: no

Package: librust-block-device-id-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         librust-libc-dev,
         librust-nix-dev (>= 0.29)
Provides: librust-block-device-id+default-dev (= ${binary:Version})
Description: Retrieve innate unique identifiers from block devices - Rust source
 A Rust library to identify block devices by their hardware-innate
 identifiers, such as MMC CID or NVMe controller serial numbers.
 .
 This package contains the Rust source code for use by other Rust packages.

Package: block-device-id
Architecture: any
Section: admin
Built-Using: ${cargo:Built-Using}
Static-Built-Using: ${cargo:Static-Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Retrieve innate unique identifiers from block devices - CLI
 A command-line tool to retrieve hardware-innate identifiers from block
 devices, such as MMC CID or NVMe controller serial numbers.
 .
 These identifiers are suitable for use in cryptographic key derivation
 or device-specific configuration.

Package: libblockdeviceid1
Architecture: any
Multi-Arch: same
Built-Using: ${cargo:Built-Using}
Static-Built-Using: ${cargo:Static-Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Retrieve innate unique identifiers from block devices - shared library
 A C-compatible shared library to identify block devices by their
 hardware-innate identifiers, such as MMC CID or NVMe controller
 serial numbers.
 .
 This package contains the shared library.

Package: libblockdeviceid-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libblockdeviceid1 (= ${binary:Version})
Description: Retrieve innate unique identifiers from block devices - development files
 A C-compatible library to identify block devices by their hardware-innate
 identifiers, such as MMC CID or NVMe controller serial numbers.
 .
 This package contains the C header files for development.

## block-device-id 0.1.1

=== debian/changelog ===
block-device-id (0.1.1) trixie; urgency=medium

  * Propagate deps to librust- package

 -- Richard Oliver <richard.oliver@raspberrypi.com>  Wed, 28 Jan 2026 15:52:27 +0000

=== debian/control ===
--- 
+++ 
@@ -20,8 +20,11 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends},
+         librust-tempfile-dev,
          librust-libc-dev,
-         librust-nix-dev (>= 0.29)
+         librust-nix-dev (>= 0.29),
+         librust-clap-dev (>= 4),
+         librust-clap-mangen-dev
 Provides: librust-block-device-id+default-dev (= ${binary:Version})
 Description: Retrieve innate unique identifiers from block devices - Rust source
  A Rust library to identify block devices by their hardware-innate

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Set proper soname for the cdylib at compile time
export RUSTFLAGS = -C link-arg=-Wl,-soname,libblockdeviceid.so.1

# Convenience variables for package staging directories
pkg_bin     = debian/block-device-id
pkg_lib     = debian/libblockdeviceid1
pkg_dev     = debian/libblockdeviceid-dev
libdir      = usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cargo

override_dh_auto_configure:
	dh_auto_configure
	# Generate cargo metadata using vendored registry for cbindgen
	# cbindgen needs metadata but will try to fetch from crates.io if not provided
	# Use CARGO_HOME=debian/cargo_home which contains config.toml that replaces crates.io
	# with the local Debian vendored registry (set up by dh_auto_configure)
	CARGO_HOME=$$(pwd)/debian/cargo_home \
		cargo metadata --format-version 1 --all-features --manifest-path Cargo.toml > debian/cargo-metadata.json
	# Generate C header using pre-generated metadata (cbindgen may create Cargo.lock, remove it)
	cbindgen --config cbindgen.toml --crate block-device-id --metadata debian/cargo-metadata.json --output block_device_id.h
	rm -f Cargo.lock

override_dh_auto_test:
	dh_auto_test
	# Verify C example compiles and links against generated header/library
	# Note: dh_auto_test uses debug builds, so library is in target/*/debug/
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -I. \
		-o debian/test-c-example examples/get_device_id.c \
		-L target/*/debug -l:libblock_device_id.so
	# Smoke test: verify binary runs (can't test real devices in build env)
	LD_LIBRARY_PATH=target/*/debug debian/test-c-example || true
	rm -f debian/test-c-example

override_dh_auto_install:
	dh_auto_install

	# --- block-device-id: CLI binary ---
	install -d $(pkg_bin)/usr/bin
	mv $(pkg_dev)/usr/bin/block-device-id $(pkg_bin)/usr/bin/
	rmdir $(pkg_dev)/usr/bin
	# Install man page from build output directory
	install -d $(pkg_bin)/usr/share/man/man1
	find target -name "block-device-id.1" -exec install -m 644 {} $(pkg_bin)/usr/share/man/man1/ \;

	# --- libblockdeviceid1: shared library ---
	install -d $(pkg_lib)/$(libdir)
	install -m 644 target/*/release/libblock_device_id.so \
		$(pkg_lib)/$(libdir)/libblockdeviceid.so.1.0.0
	ln -s libblockdeviceid.so.1.0.0 $(pkg_lib)/$(libdir)/libblockdeviceid.so.1

	# --- libblockdeviceid-dev: development files ---
	install -d $(pkg_dev)/$(libdir)
	ln -s libblockdeviceid.so.1 $(pkg_dev)/$(libdir)/libblockdeviceid.so
	install -d $(pkg_dev)/usr/include
	install -m 644 block_device_id.h $(pkg_dev)/usr/include/
	install -d $(pkg_dev)/usr/share/doc/libblockdeviceid-dev/examples
	install -m 644 examples/get_device_id.c examples/Makefile \
		$(pkg_dev)/usr/share/doc/libblockdeviceid-dev/examples/

override_dh_makeshlibs:
	# Only process the shared library package (block-device-id has no libs)
	dh_makeshlibs -p libblockdeviceid1

override_dh_shlibdeps:
	dh_shlibdeps -l $(pkg_lib)/$(libdir)

override_dh_gencontrol:
	# Generate Built-Using/Static-Built-Using for packages with compiled Rust
	# (not libblockdeviceid-dev: it only contains generated header + symlink)
	/usr/share/cargo/bin/dh-cargo-built-using block-device-id
	/usr/share/cargo/bin/dh-cargo-built-using libblockdeviceid1
	# Clear unused substvars for -dev package to suppress warnings
	sed -i '/^cargo:/d' $(pkg_dev).substvars 2>/dev/null || true
	dh_gencontrol
